## org.jgroups.protocols
Class VIEW_SYNC

    java.lang.Object
      org.jgroups.stack.Protocol
          org.jgroups.protocols.VIEW_SYNC

    public class VIEW_SYNC

extends Protocol

Periodically sends the view to the group. When a view is received which is greater than the current view, we install it. Otherwise we simply discard it. This is used to solve the problem for unreliable view dissemination outlined in JGroups/doc/ReliableViewInstallation.txt. This protocol is supposed to be just below GMS.

Author:
  Bela Ban

Nested Class Summary
`static class` `VIEW_SYNC.ViewSyncHeader`

Field Summary

Fields inherited from class org.jgroups.stack.Protocol
`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

Constructor Summary
`VIEW_SYNC()`

Method Summary
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`long` `getAverageSendInterval()`
`int` `getNumViewsAdjusted()`
`int` `getNumViewsSent()`
`void` `resetStats()`
`void` `sendViewRequest()` Sends a VIEW_SYNC_REQ to all members, every member replies with a VIEW multicast
`void` `setAverageSendInterval(long gossip_interval)`
`void` `start()` This method is called on a `Channel.connect(String)`.
`void` `stop()` This method is called on a `Channel.disconnect()`.
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, init, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VIEW_SYNC

    public VIEW_SYNC()

Method Detail

### getAverageSendInterval

    public long getAverageSendInterval()

### setAverageSendInterval

    public void setAverageSendInterval(long gossip_interval)

### getNumViewsSent

    public int getNumViewsSent()

### getNumViewsAdjusted

    public int getNumViewsAdjusted()

### resetStats

    public void resetStats()

  Overrides:
    `resetStats` in class `Protocol`

### start

    public void start()
               throws java.lang.Exception

  Description copied from class: `Protocol`
  This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

  Overrides:
    `start` in class `Protocol`
  Throws:
    `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

### stop

    public void stop()

  Description copied from class: `Protocol`
  This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

  Overrides:
    `stop` in class `Protocol`

### sendViewRequest

    public void sendViewRequest()

  Sends a VIEW_SYNC_REQ to all members, every member replies with a VIEW multicast

### up

    public java.lang.Object up(Event evt)

  Description copied from class: `Protocol`
  An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

  Overrides:
    `up` in class `Protocol`

### down

    public java.lang.Object down(Event evt)

  Description copied from class: `Protocol`
  An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

  Overrides:
    `down` in class `Protocol`

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.